﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinTree;

namespace WindowsFormsApplication13
{
    public partial class Form1 : Form
    {
        private IList<DataSource> _ds = new List<DataSource>();
        private IList<Tester> _testers = new List<Tester>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var root = new Tester() {Id = 1, Name = "Root", Parent = null };
            var level1_1 = new Tester() {Id = 2, Name = "Level1_1", Parent = root };
            var level1_2 = new Tester() {Id = 3, Name = "Level1_2", Parent = root };
            var level2_1 = new Tester() {Id = 4, Name = "level2_1", Parent = level1_1 };

            _testers.Add(root);
            _testers.Add(level1_1);
            _testers.Add(level1_2);
            _testers.Add(level2_1);

            _ds.Add(new DataSource() { Id = 1, Tester = level1_1});
            _ds.Add(new DataSource() { Id = 2, Tester = level2_1 });

            this.ultraGrid1.DataSource = _ds;

            FormUtility.FillTree(this.phDropDownTreeView1.TreeView, _testers);
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Tester"].EditorComponent = this.phDropDownTreeView1;
        }

        private void phDropDownTreeView1_PHBeforeEditorButtonDropDown(object sender, Infragistics.Win.UltraWinEditors.BeforeEditorButtonDropDownEventArgs e)
        {
            this.phDropDownTreeView1.TreeView.SelectedNodes.Clear();
            this.phDropDownTreeView1.TreeView.CollapseAll();
            UltraGridRow row = this.ultraGrid1.ActiveRow;
            if (row != null)
            {
                UltraGridCell cell = row.Cells["Tester"];
                if (cell != null && cell.Value != null)
                {
                    UltraTreeNode node = this.phDropDownTreeView1.TreeView.GetNodeByKey(FormUtility.TREE_NODE_ORGANISATION + cell.Value.ToString());
                    if (node != null)
                    {
                        node.Selected = true;
                    }
                }
            }
        }

        private void phDropDownTreeView1_PHBeforeSelect(object sender, BeforeSelectEventArgs e)
        {
            foreach (UltraTreeNode node in e.NewSelections)
            {
                if (node.Key.Contains(FormUtility.TREE_NODE_ORGANISATION) == false)
                {
                    e.Cancel = true;
                }
            }
        }

        private void phDropDownTreeView1_PHAfterEditorButtonCloseUp(object sender, Infragistics.Win.UltraWinEditors.EditorButtonEventArgs e)
        {
            if (this.phDropDownTreeView1.TreeView.SelectedNodes != null && this.phDropDownTreeView1.TreeView.SelectedNodes.Count > 0)
            {
                UltraTreeNode node = this.phDropDownTreeView1.TreeView.SelectedNodes[0];
                if (this.ultraGrid1.ActiveRow != null)
                {
                    UltraGridRow row = this.ultraGrid1.ActiveRow;
                    row.Cells["Tester"].Value = this.phDropDownTreeView1.TreeView.SelectedNodes[0].Tag;
                }
            }

        }
    }
}
